<?xml version="1.0" encoding="utf-8"?>
<xs:schema xmlns:tns="http://www.s60.com/xml/confml/2"
           xmlns:xs="http://www.w3.org/2001/XMLSchema"
           xmlns:xlink="http://www.w3.org/1999/xlink"
           xmlns:xi="http://www.w3.org/2001/XInclude"
           xmlns:xml="http://www.w3.org/XML/1998/namespace"
           targetNamespace="http://www.s60.com/xml/confml/2"
           elementFormDefault="qualified"
           attributeFormDefault="unqualified">
  <xs:import namespace="http://www.w3.org/2001/XMLSchema"
             id="xs" schemaLocation="XMLSchema.xsd"/>
  <xs:import namespace="http://www.w3.org/1999/xlink"
             id="xlink" schemaLocation="xlink.xsd" />
  <xs:import namespace="http://www.w3.org/2001/XInclude"
             id="xi" schemaLocation="XInclude.xsd" />
  <xs:import namespace="http://www.w3.org/XML/1998/namespace"
             id="xml" schemaLocation="xml.xsd"/>
	     
  <xs:element name="configuration"
              type="tns:configurationType" />
  <xs:element name="meta"
              type="tns:metaType" />
  <xs:element name="desc"
              type="tns:descType" />
  <xs:element name="icon"
              type="tns:iconType" />
  <xs:element name="view"
              type="tns:viewType" />
  <xs:element name="group"
              type="tns:groupType" />
  <xs:element name="feature"
              type="tns:featureType" />
  <xs:element name="setting"
              type="tns:settingType" />
  <xs:element name="data"
              type="tns:dataType" />
  <xs:element name="rfs"
              type="tns:rfsType" />
  <xs:element name="link"
              type="tns:linkType" />
  <xs:element name="option"
              type="tns:optionType" />
  <xs:element name="property"
              type="tns:propertyType" />
  <xs:element name="localPath"
              type="tns:pathType" />
  <xs:element name="targetPath"
              type="tns:pathType" />
  <xs:element name="extensions"
              type="tns:extensionsType" />
  <xs:complexType name="extensionsType">
    <xs:choice minOccurs="0"
               maxOccurs="unbounded">
      <xs:any namespace="##other"
              processContents="skip"
              minOccurs="0"
              maxOccurs="unbounded" />
    </xs:choice>
    <xs:attributeGroup ref="tns:CommonAttrs" />
  </xs:complexType>
  <xs:complexType name="configurationType">
    <xs:choice minOccurs="0"
               maxOccurs="unbounded">
      <xs:element ref="tns:meta"
                  maxOccurs="1" />
      <xs:element ref="tns:desc" />
      <xs:element ref="tns:icon" />
      <xs:element ref="tns:view" />
      <xs:element ref="tns:feature" />
      <xs:element ref="tns:link" />
      <xs:element ref="tns:data"
                  maxOccurs="1" />
      <xs:element ref="tns:rfs"
                  maxOccurs="1" />
      <xs:element ref="tns:configuration" />
      <xs:element ref="xi:include" />
      <xs:element ref="tns:extensions" />
    </xs:choice>
    <xs:attribute name="version"
                  use="required">
      <xs:simpleType>
        <xs:restriction base="xs:token">
          <xs:pattern value="[0-9]{1,3}\.[0-9]{1,3}(\.[0-9]{1,3})?" />
          <!-- This regexp matches versions declared as x.y[.z] -->
        </xs:restriction>
      </xs:simpleType>
    </xs:attribute>
    <xs:attribute name="name"
                  type="xs:token" />
    <xs:attributeGroup ref="tns:CommonAttrs" />
    <xs:attribute ref="xml:base" />
    <xs:anyAttribute namespace="##other"
                     processContents="skip" />
  </xs:complexType>
  <xs:complexType name="metaType">
    <xs:choice minOccurs="0"
               maxOccurs="unbounded">
      <xs:element name="id"
                  type="tns:idType" />
      <xs:element name="date"
                  type="tns:dateType" />
      <xs:element name="owner"
                  type="tns:ownerType" />
      <xs:element name="editor"
                  type="tns:editorType" />
      <xs:element name="status"
                  type="tns:statusType" />
      <xs:element name="version"
                  type="tns:versionType" />
      <xs:element name="platform"
                  type="tns:platformType" />
      <xs:element name="product"
                  type="tns:productType" />
      <xs:element name="release"
                  type="tns:releaseType" />
      <xs:element name="customer"
                  type="tns:customerType" />
      <xs:element name="origin"
                  type="tns:originType" />
      <xs:element name="target"
                  type="tns:targetType" />
      <xs:element name="desc"
                  type="tns:descType" />
      <xs:element name="icon"
                  type="tns:iconType" />
      <xs:element ref="tns:link" />
      <xs:element ref="tns:extensions" />
    </xs:choice>
  </xs:complexType>
  <xs:complexType name="descType"
                  mixed="true">
    <xs:attribute ref="xlink:href" />
    <xs:attribute ref="xlink:title" />
    <xs:attributeGroup ref="tns:CommonAttrs" />
  </xs:complexType>
  <xs:complexType name="iconType">
    <xs:attribute ref="xlink:href"
                  use="optional" />
    <xs:attribute ref="xlink:title" />
    <xs:attributeGroup ref="tns:CommonAttrs" />
  </xs:complexType>
  <xs:complexType name="linkType">
    <xs:attribute ref="xlink:href"
                  use="optional" />
    <xs:attribute ref="xlink:title" />
    <xs:attributeGroup ref="tns:CommonAttrs" />
  </xs:complexType>
  <xs:complexType name="propertyType">
    <xs:choice minOccurs="0"
               maxOccurs="unbounded">
      <xs:element ref="tns:desc" />
      <xs:element ref="tns:icon" />
      <xs:element ref="tns:link" />
    </xs:choice>
    <xs:attributeGroup ref="tns:CommonAttrs" />
    <xs:attribute name="name"
                  type="xs:token"
                  use="optional" />
    <xs:attribute name="value"
                  type="xs:string"
                  use="optional" />
    <xs:attribute name="unit"
                  type="xs:token" />
  </xs:complexType>
  <xs:complexType name="settingType">
    <xs:choice minOccurs="0"
               maxOccurs="unbounded">
      <xs:element ref="tns:desc" />
      <xs:element ref="tns:icon" />
      <xs:element ref="tns:link" />
      <xs:element ref="tns:option" />
      <xs:element ref="tns:property" />
      <xs:element ref="tns:setting" />
      <xs:element ref="tns:localPath" />
      <xs:element ref="tns:targetPath" />
      <xs:element ref="xs:pattern" />
      <xs:element ref="xs:minInclusive" />
      <xs:element ref="xs:maxInclusive" />
      <xs:element ref="xs:minExclusive" />
      <xs:element ref="xs:maxExclusive" />
      <xs:element ref="xs:length" />
      <xs:element ref="xs:minLength" />
      <xs:element ref="xs:maxLength" />
      <xs:element ref="xs:totalDigits" />
      <xs:element ref="tns:extensions" />
    </xs:choice>
    <xs:attributeGroup ref="tns:CommonAttrs" />
    <xs:attribute name="relevant"
                  type="xs:token"
                  default="true" />
    <xs:attribute name="constraint"
                  type="xs:token"
                  default="true" />
    <xs:attribute name="readOnly"
                  type="xs:boolean"
                  default="false" />
    <xs:attribute name="name"
                  type="xs:string" />
    <xs:attribute name="type"
                  type="tns:typeType" />
    <xs:attribute name="ref"
                  type="xs:token" />
    <xs:attribute name="minOccurs"
                  type="xs:nonNegativeInteger"
                  default="0" />
    <xs:attribute name="maxOccurs"
                  type="xs:NMTOKEN"
                  default="unbounded" />
    <xs:attribute name="displayName"
                  type="xs:string" />
    <xs:attribute name="mapKey"
                  type="xs:string" />
    <xs:attribute name="mapValue"
                  type="xs:string" />
    <xs:attribute name="required"
                  type="xs:boolean"
                  default="false" />
    <xs:anyAttribute namespace="##other"
                     processContents="skip" />
  </xs:complexType>
  <xs:complexType name="featureType">
    <xs:choice minOccurs="0"
               maxOccurs="unbounded">
      <xs:element ref="tns:desc" />
      <xs:element ref="tns:icon" />
      <xs:element ref="tns:link" />
      <xs:element ref="tns:setting" />
      <xs:element ref="tns:extensions" />
    </xs:choice>
    <xs:attribute name="name"
                  type="xs:token" />
    <xs:attribute name="relevant"
                  type="xs:token"
                  default="true" />
    <xs:attribute name="ref"
                  type="xs:token"
                  use="required" />
    <xs:attributeGroup ref="tns:CommonAttrs" />
    <xs:anyAttribute namespace="##other"
                     processContents="skip" />
  </xs:complexType>
  <xs:complexType name="optionType">
    <xs:choice minOccurs="0"
               maxOccurs="unbounded">
      <xs:element ref="tns:desc" />
      <xs:element ref="tns:icon" />
      <xs:element ref="tns:link" />
    </xs:choice>
    <xs:attributeGroup ref="tns:CommonAttrs" />
    <xs:attribute name="name"
                  type="xs:token" />
    <xs:attribute name="value"
                  type="xs:string" />
    <xs:attribute name="relevant"
                  type="xs:token"
                  default="true" />
    <xs:attribute name="map"
                  type="xs:string" />
    <xs:attribute name="mapValue"
                  type="xs:string" />
    <xs:attribute name="displayName"
                  type="xs:string" />
    <xs:anyAttribute namespace="##other"
                     processContents="skip" />
  </xs:complexType>
  <xs:complexType name="groupType">
    <xs:choice minOccurs="0"
               maxOccurs="unbounded">
      <xs:element ref="tns:desc" />
      <xs:element ref="tns:icon" />
      <xs:element ref="tns:link" />
      <xs:element ref="tns:group" />
      <xs:element ref="tns:setting" />
    </xs:choice>
    <xs:attributeGroup ref="tns:CommonAttrs" />
    <xs:attribute name="name"
                  type="xs:token" />
  </xs:complexType>
  <xs:complexType name="viewType">
    <xs:choice minOccurs="0"
               maxOccurs="unbounded">
      <xs:element ref="tns:meta"
                  maxOccurs="1" />
      <xs:element ref="tns:desc" />
      <xs:element ref="tns:icon" />
      <xs:element ref="tns:link" />
      <xs:element ref="tns:group" />
    </xs:choice>
    <xs:attributeGroup ref="tns:CommonAttrs" />
    <xs:attribute name="name"
                  type="xs:token" />
  </xs:complexType>
  <xs:simpleType name="idType">
    <xs:restriction base="xs:NMTOKEN" />
  </xs:simpleType>
  <xs:simpleType name="dateType">
    <xs:restriction base="xs:date" />
  </xs:simpleType>
  <xs:simpleType name="ownerType">
    <xs:restriction base="xs:string" />
  </xs:simpleType>
  <xs:simpleType name="editorType">
    <xs:restriction base="xs:string" />
  </xs:simpleType>
  <xs:simpleType name="productType">
    <xs:restriction base="xs:string" />
  </xs:simpleType>
  <xs:simpleType name="statusType">
    <xs:restriction base="xs:string" />
  </xs:simpleType>
  <xs:simpleType name="platformType">
    <xs:restriction base="xs:string" />
  </xs:simpleType>
  <xs:simpleType name="versionType">
    <xs:restriction base="xs:string" />
  </xs:simpleType>
  <xs:simpleType name="releaseType">
    <xs:restriction base="xs:string" />
  </xs:simpleType>
  <xs:simpleType name="customerType">
    <xs:restriction base="xs:string" />
  </xs:simpleType>
  <xs:simpleType name="originType">
    <xs:restriction base="xs:string" />
  </xs:simpleType>
  <xs:simpleType name="targetType">
    <xs:restriction base="xs:string" />
  </xs:simpleType>
  <xs:attributeGroup name="CommonAttrs">
    <xs:attribute name="id"
                  type="xs:NMTOKEN" />
  </xs:attributeGroup>
  <xs:complexType name="dataType">
    <xs:sequence>
      <xs:any namespace="##any"
              processContents="skip"
              minOccurs="0"
              maxOccurs="unbounded" />
    </xs:sequence>
    <xs:attributeGroup ref="tns:CommonAttrs" />
    <xs:attribute name="extensionPolicy"
                  type="xs:NMTOKEN"
                  default="replace" />
    <xs:attribute name="template"
                  type="xs:NMTOKEN"
                  default="false" />
    <xs:attribute name="map"
                  type="xs:string" />
    <xs:attribute name="empty"
                  type="xs:NMTOKEN"
                  default="false" />
  </xs:complexType>
  <xs:complexType name="rfsType">
    <xs:sequence>
      <xs:any namespace="##any"
              processContents="skip"
              minOccurs="0"
              maxOccurs="unbounded" />
    </xs:sequence>
    <xs:attributeGroup ref="tns:CommonAttrs" />
  </xs:complexType>
  <xs:simpleType name="typeType">
    <xs:restriction base="xs:string">
      <xs:enumeration value="int" />
      <xs:enumeration value="boolean" />
      <xs:enumeration value="real" />
      <xs:enumeration value="string" />
      <xs:enumeration value="file" />
      <xs:enumeration value="folder" />
      <xs:enumeration value="sequence" />
      <xs:enumeration value="selection" />
      <xs:enumeration value="multiSelection" />
      <xs:enumeration value="date" />
      <xs:enumeration value="time" />
      <xs:enumeration value="dateTime" />
      <xs:enumeration value="duration" />
      <xs:enumeration value="hexBinary" />
    </xs:restriction>
  </xs:simpleType>
  <xs:complexType name="pathType"
                  mixed="true">
    <xs:choice minOccurs="0"
               maxOccurs="unbounded">
      <xs:element ref="tns:desc" />
      <xs:element ref="tns:icon" />
      <xs:element ref="tns:link" />
      <xs:element ref="xs:pattern" />
      <xs:element ref="xs:length" />
      <xs:element ref="xs:minLength" />
      <xs:element ref="xs:maxLength" />
      <xs:element ref="tns:property" />
    </xs:choice>
    <xs:attributeGroup ref="tns:CommonAttrs" />
    <xs:attribute name="constraint"
                  type="xs:token"
                  default="true" />
    <xs:attribute name="readOnly"
                  type="xs:boolean"
                  default="false" />
    <xs:attribute name="required"
                  type="xs:boolean"
                  default="false" />
    <xs:attribute name="map"
                  type="xs:string" />
  </xs:complexType>
</xs:schema>
